/*
 * @(#)CivLogDraw.java - responsible for draw the graph
 * needs to be optimized a lot
 *
 * Created on July 23, 2000, 4:37 PM
 */

/**
 *
 * @author  furyhawk
 * @version 0.10
 */

/**
   ********************************************************************
 CivLog - Copyright (C) 2000 - Wong Teck Meng
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
**********************************************************************
                                                                      */

//package CivLogDraw;

import java.awt.*;
import java.awt.event.*;

import java.util.*;

import javax.swing.*;

public class CivLogDraw extends javax.swing.JPanel {

  private int currentData = -1; // what data is shown, references a constant from Freeciv.java; was static before, no idea why
  int startYear, endYear;
  private int currentTurnRange; /** */

  float spaceshipScale, timeScale;
  float scale[] = new float[14];
  private CivLogData civLogData;

  private static Color color[] = {Color.black, Color.blue, Color.cyan, Color.yellow,
                   Color.pink, Color.green, Color.orange, Color.magenta,
                   Color.lightGray, Color.red, Color.gray, Color.darkGray};
  private static final int TotalColor = color.length; // 12

  private int x2, y2;

  /** Creates new form CivLogDraw */
  public CivLogDraw (CivLogData data) {
    Debug.trace( "CivLogDraw.CivLogDraw(): initializing" );
    /** is the data a copy or point to the newer one */
    civLogData = data;
    initComponents ();
    setBackground (Color.white);
    startYear = -4000;
    endYear   = 2000;
    Debug.trace( "CivLogDraw.CivLogDraw(): done" );
  }

  /** added constructor which takes one more argument (currentData)
   *  it is needed so we can have multiple graphs
   */
  public CivLogDraw (CivLogData data, int currentData) {
    this(data);
    this.currentData = currentData;
    // Debug.trace( "CivLogDraw.CivLogDraw(): currentData = "+this.currentData );
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents () {//GEN-BEGIN:initComponents
    setLayout (new java.awt.BorderLayout ());
    setPreferredSize (new java.awt.Dimension (500, 100));
    setBorder (new javax.swing.border.TitledBorder (""));
    setMinimumSize (new java.awt.Dimension (500, 100));

  }//GEN-END:initComponents

  public void paint (Graphics g) {

    super.paint(g);

    /** check if any data is loaded */
    if (civLogData.numofPlayers == 0)
      Debug.trace( "CivLogDraw.paint(): no permission or data empty: numofPlayers" );
    if (civLogData.civscore.isEmpty ())
      Debug.trace( "CivLogDraw.paint(): no permission or data empty: civscore empty" );
    if (civLogData.selectedPlayers.isEmpty())
      Debug.trace( "CivLogDraw.paint(): no permission or data empty: selectedPlayers isEmpty" );
    if (currentData == -1)
      Debug.trace( "CivLogDraw.paint(): no permission or data empty: currentData == -1" );

    if ( (civLogData.numofPlayers == 0) || (civLogData.civscore.isEmpty ())
         || (currentData == -1) || (civLogData.selectedPlayers.isEmpty()) ) {
      Debug.trace( "CivLogDraw.paint(): no permission or data empty" );
    }
    else {
      drawGraph(g);
    }

    return;

  }/* end - paint() */

  /**
     ***********************************************************
  *  drawGraph() -
  *
  *
  *
  **************************************************************
                                                                */
  public void drawGraph (Graphics g) {

    Debug.trace( "CivLogDraw.drawGraph(): initializing");

    Dimension d = getSize ();
    /* draw the current lines */
    g.setColor (getForeground ());

    /** initalize data here */
    x2 = 0;
    y2 = 0;
    int value = 0;
    int index = 0;
    currentTurnRange = 0;

    Vector line = new Vector();

    /** for each selected player add a PolyLine in Vector line */
    for (int z=0; z < civLogData.selectedPlayers.size(); z++ ) {
      line.addElement ( new PolyLine() );
    }

    rescale (d);

    currentTurnRange = calculateFreeCivTurns ();

    timeScale = (float)(d.width / currentTurnRange);

    Debug.trace( "CivLogDraw.paint(): timescale: " + timeScale + " turnRange: "
                  + currentTurnRange);

// old code, left just for reference or comparison -> remove if no longer needed

    /** TODO: optimize here */ /* I did :-) */
     // for (int i=0; i < civLogData.civscore.size (); i++) {
     // CivLogDataEntry current = (CivLogDataEntry)civLogData.civscore.elementAt (i);
      /** filter what to process */
//      if ( (current.year > startYear) && (current.year < endYear)) {
//        for (int j=0; j < civLogData.selectedPlayers.size (); j++) {
//          Integer idx = (Integer)civLogData.selectedPlayers.elementAt (j);
//        index = idx.intValue ();
//
//        if ( current.player == index) {
//          /** error checking?? */
//          value = current.get_data (currentData); /** get selected data */
//          y2 = Math.round ( d.height - (value*scale[currentData])); /** scale the value */
//          PolyLine theLine = (PolyLine)line.elementAt(j);
//          theLine.addPoint (x2, y2, value);
//
//          theLine.currentX += timeScale; /** not redundant, for higher resolution scale */
//          x2 = Math.round (theLine.currentX);
//        }
//
//          //Debug.trace("value: " + value);
//        }/* end - for */
//      }/* end- if */
//    }/* end - for */

    // emulate the previous behavior with new data structures

    // 1st solution, did not work because we need it sorted by year (didn't know that)
    // maybe a Hash wasn't such a good idea...
    // Collection c = civLogData.civscore.values();
    // Iterator it = c.iterator();

    // 2nd solution, works but may be too slow on other computers (but worked for me)
    // TreeSet s = new TreeSet(civLogData.civscore.keySet());
    // Iterator it = s.iterator();

    // the sorting should probably be done once and not each time paint is called, so:
    // 3rd solution, sorting is done once in CivLogData in an Array civscoreArray
    Iterator it = civLogData.civscoreArray.iterator();

    while (it.hasNext()) {
      // get next (sorted) CivLogYearEntry from HashMap
      CivLogYearEntry y = (CivLogYearEntry) civLogData.civscore.get((Integer) it.next());
      /** a little hard to read:                                              get next year from iterator
       *                                                             make Integer from year
       *                                                       fetch year-entry from HashMap
       *                   cast to CivLogYearEntry
       */

      /** filter what to process */
      if ( (y.getYear() > startYear) && (y.getYear() < endYear)) {
        //Debug.trace ( "CivLogDraw.drawGraph(): year value = "+y.getYear());
        //Debug.trace ( "CivLogDraw.drawGraph(): selectedPlayers: "+civLogData.selectedPlayers.size ());
        for (int j=0; j < civLogData.selectedPlayers.size (); j++) {
          Integer idx = (Integer)civLogData.selectedPlayers.elementAt (j);
          index = idx.intValue ();
          //Debug.trace ( "CivLogDraw.drawGraph(): index: "+index);
          // get entry for player idx from the CivLogYearEntry (which is a HashMap also
          CivLogDataEntry current = (CivLogDataEntry) y.get(idx);

          if ( current.player == index) { // now it always is by design?
            /** error checking?? */
            value = current.get_data (currentData); /** get selected data */
            y2 = Math.round ( d.height - (value*scale[currentData])); /** scale the value */
            PolyLine theLine = (PolyLine)line.elementAt(j);
            theLine.addPoint (x2, y2, value);
            theLine.currentX += timeScale; /** not redundant, for higher resolution scale */
            x2 = Math.round (theLine.currentX);
          }
          //Debug.trace("value: " + value);
        }/* end - for */
      }/* end- if */
    }/* end - while */


    /** Assign Players Names to the label */
    for (int j=0; j < civLogData.selectedPlayers.size (); j++) {
      Integer idx = (Integer)civLogData.selectedPlayers.elementAt (j);
      index = idx.intValue ();
      PolyLine theLine = (PolyLine)line.elementAt (j);
      theLine.setLabel ( (String)civLogData.playerNames.elementAt (index));

      // theLine.setColor ( color[j%(TotalColor-1)]);
      /** changed, so that each player has the same color, regardless of which
       *  other players are selected (previously colors were changing)
       *  negative side-effect: if more than 12 players and only players 1 and 13
       *  were selected, they would have same color, therefore if > 12 players old way
       */
      if (civLogData.getNumPlayers() <= TotalColor)
        theLine.setColor ( color[index]);
      else
        theLine.setColor ( color[j%(TotalColor-1)]);
    }

    Font font = g.getFont ();
    font = font.deriveFont ( (float)9.0);
    g.setFont (font);

    for (int y=0; y < civLogData.selectedPlayers.size (); y++ ) {
      PolyLine theLine = (PolyLine)line.elementAt (y);

      if (civLogData.selectedPlayers.size () == 1) {
        theLine.drawAverage (g, d, scale[currentData]);
        theLine.drawPolyLine (g);
        theLine.drawLabel (g, d.height);
        theLine.drawMaxPoint (g);
        theLine.drawMinPoint (g);
      }
      /** draw only a few things if more than one graph */
      else {
        theLine.drawPolyLine (g);
        theLine.drawLabel (g, d.height);
        theLine.drawMaxPoint (g);
      }
    }

    /** Label this drawing-area with the data type */
    g.setColor (Color.black);
    // String should be created in constructor or init
    String dataLabel = Freeciv.DATA_DESCRIPTION[currentData];
    g.drawString (dataLabel, 20, 20);


    Debug.trace ( "CivLogDraw.drawGraph(): done");
  }/* end - drawGraph() */

  int calculateFreeCivTurns () {

    int turns = 0;

    /** this updated formula is the one giving me the bigest headache */
    /** add a +1 to this formula to be more accurate */
    /** this formula calculate the no. of turn between any two freeciv years (>= -4000) */
    /** -4000 <= x < -1000, 50 turns */
    turns =  Math.abs ( (Math.min (Math.max (startYear,-4000), -999)
    - Math.min (Math.max (endYear,  -4000), -999)) / 50);
    /** -1000 <= x < -1, 25 turns */
    turns += Math.abs ( (Math.min (Math.max (startYear,-1000),   -1)
    - Math.min (Math.max (endYear,  -1000),   -1)) / 25);
    /** 0 <= x < 1000, 20 turns */
    turns += Math.abs ( (Math.min (Math.max (startYear,    0),  999)
    - Math.min (Math.max (endYear,      0),  999)) / 20);
    /** 1000 <= x < 1500, 10 turns */
    turns += Math.abs ( (Math.min (Math.max (startYear, 1000), 1499)
    - Math.min (Math.max (endYear,   1000), 1499)) / 10);
    /** 1500 <= x < 1750, 5 turns */
    turns += Math.abs ( (Math.min (Math.max (startYear, 1500), 1749)
    - Math.min (Math.max (endYear,   1500), 1749)) / 5);
    /** 1750 <= x < 1900, 2 turns */
    turns += Math.abs ( (Math.min (Math.max (startYear, 1750), 1899)
    - Math.min (Math.max (endYear,   1750), 1899)) / 2);
    /** 1900 <= x, 1 turn */
    turns += Math.abs ( (Math.max (startYear, 1900) - Math.max (endYear, 1900)) / 1);

    return (turns+1);
  }

  void rescale (Dimension d) {

    /** scale factors */
    scale[Freeciv.POP]         = (float)d.height / (civLogData.maxPop + 10); /** Avg: 250 */
    scale[Freeciv.BNP]         = (float)d.height / (civLogData.maxBnp + 25); /** Avg: 550 */
    scale[Freeciv.MFG]         = (float)d.height / (civLogData.maxMfg + 12); /** Avg: 190 */
    scale[Freeciv.CITIES]      = (float)d.height / (civLogData.maxCities + 3); /** Avg: 60 */
    scale[Freeciv.TECHS]       = (float)d.height / (civLogData.maxTechs + 3); /** Avg: 40 */
    scale[Freeciv.MUNITS]      = (float)d.height / (civLogData.maxMunits + 4); /** Avg: 55 */
    scale[Freeciv.SETTLERS]    = (float)d.height / (civLogData.maxSettlers + 1); /** Avg: 12 */
    scale[Freeciv.WONDERS]     = (float)d.height / (civLogData.maxWonders + 1); /** Avg: 4 */
    scale[Freeciv.TECHOUT]     = (float)d.height / (civLogData.maxTechout + 18); /** Avg: 320 */
    scale[Freeciv.LANDAREA]    = (float)d.height / (civLogData.maxLandArea + 40000); /** Avg: 540000 */
    scale[Freeciv.SETTLEDAREA] = (float)d.height / (civLogData.maxSettledArea + 30000); /** Avg: 476000 */
    scale[Freeciv.POLLUTION]   = (float)d.height / (civLogData.maxPollution + 1); /** Avg: ? */
    scale[Freeciv.LITERACY]    = (float)d.height / (civLogData.maxLiteracy + 1); /** Avg: ? */
    scale[Freeciv.SPACESHIP]   = (float)d.height / (civLogData.maxSpaceship + 1); /** Avg: ? */

  }

  // Variables declaration - do not modify//GEN-BEGIN:variables
  // End of variables declaration//GEN-END:variables

}
// end of CivLogDraw.java