/*
 * @(#)CivLogDrawArea.java - Container in the center, holds all the CivLogDraw-Objects
 *
 *
 * Created on August 25, 2000
 */

/**
 *
 * @author  Michael Grundel <michael42@grundel.de>
 * @version
 */

/**********************************************************************
 CivLog - Copyright (C) 2000 - Wong Teck Meng
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
********************************************************************* */

import java.awt.*;
import java.util.*;

public class CivLogDrawArea extends javax.swing.JPanel {

  public CivLogDrawArea () {
    setLayout(new GridLayout(0,1)); // 1 column, 0 rows = as many as needed
    setVisible(true);
  }

  /** try to add a CivLogDraw Object to the center
   *  if it already is in there, it will not be added (Set contains no dupes)
   */
  void addDraw(CivLogDraw d) {
      Debug.trace ( "CivLogDrawArea.addDraw(): adding" );
      add(d);
      getLayout().layoutContainer(this);
      repaint(); // if this is not there, display is not updated when all types removed and then one is added
      //revalidate(); // seems to be no need for this
  }

  /** try to remove a CivLogDraw Object from the center
   *  if it is not in there, nothing will happen
   */
  void removeDraw(CivLogDraw d) {
      Debug.trace ( "CivLogDrawArea.removeDraw(): removing" );
      remove(d);
      getLayout().layoutContainer(this);
      repaint();
    //  revalidate();
  }

// seems to be working without this
/*  public void repaint() {
    super.repaint();
    revalidate();
  }
*/
}